VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EditHistory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Event HistoryChanged(HistoryState As HistoryState)
Private mSteps() As EditStep
Private mStepUbound As Long
Private mCurStep As Long
Private mBox As XBox

Private Sub Class_Initialize()
mStepUbound = -1
mCurStep = -1
End Sub

Public Property Get CurStep() As EditStep
On Error Resume Next
Set CurStep = mSteps(mCurStep)
End Property

Public Property Get CurStepNumber() As Long
CurStepNumber = mCurStep
End Property

Public Function AddStep(Optional ByVal CursorX As Long = -1, Optional ByVal CursorY As Long = -1) As EditStep
mCurStep = mCurStep + 1
mStepUbound = mCurStep
ReDim Preserve mSteps(mStepUbound)
Set mSteps(mCurStep) = New EditStep
mSteps(mCurStep).SaveCursorPos IIf(CursorX < 0, mX, CursorX), IIf(CursorY < 0, mY, CursorY)
Set AddStep = mSteps(mCurStep)
RaiseEvent HistoryChanged(NoRedoHistory)
End Function

Public Sub Undo()
If mCurStep < 0 Then Exit Sub
'mBox.HideCaret
mSteps(mCurStep).Restore
mCurStep = mCurStep - 1
'mBox.ShowCaret
RaiseEvent HistoryChanged(IIf(mCurStep < 0, HistoryState.NoUndoHistory, HistoryState.InHistory))
End Sub

Public Sub Redo()
If mCurStep = mStepUbound Then Exit Sub
'mBox.HideCaret
mCurStep = mCurStep + 1
mSteps(mCurStep).Restore
'mBox.ShowCaret
RaiseEvent HistoryChanged(IIf(mCurStep = mStepUbound, HistoryState.NoRedoHistory, HistoryState.InHistory))
End Sub

Private Sub Class_Terminate()
Set mBox = Nothing
End Sub

Public Property Set Box(ByRef NewBox As XBox)
Set mBox = NewBox
End Property

Public Sub CancelAddStep()
If mCurStep < 0 Then Exit Sub
mCurStep = mCurStep - 1
mStepUbound = mCurStep
End Sub

Public Sub ClearHistory()
mStepUbound = -1
mCurStep = -1
Erase mSteps
RaiseEvent HistoryChanged(HistoryState.NoHistory)
End Sub

Public Property Get StepCount() As Long
StepCount = mStepUbound + 1
End Property

'Public Property Get HistoryState() As HistoryState
'If mStepUbound = -1 Then
'    HistoryState = NoHistory
'ElseIf mCurStep < 0 Then
'    HistoryState = NoUndoHistory
'ElseIf mCurStep = mstepcount Then
'    HistoryState = NoRedoHistory
'Else
'    HistoryState = InHistory
'End If
'End Property

