VERSION 5.00
Begin VB.UserControl ToolBar 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1590
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6390
   KeyPreview      =   -1  'True
   MaskColor       =   &H00000000&
   PaletteMode     =   0  'Halftone
   ScaleHeight     =   106
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   426
   ToolboxBitmap   =   "XToolBar.ctx":0000
End
Attribute VB_Name = "ToolBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Public Buttons As Collection
Public ButtonCount As Long, SplitCount As Long
Private CurButton As Long
Private ButtonDowned As Boolean
Private DownedButton As Long
Private bgBrush As Long
Private CheckBack As StdPicture
Private mEnabled As Boolean
Public Event Click(Button As Button, X As Single, Y As Single)
Public Event ButtonHover(HoverOut As Boolean, Button As Button)
Private mToolTip As cTooltip

Public Sub AddButton(Key As String, Optional CheckStyle As Boolean = False, Optional ToolTipText As String = "", Optional ButtonEnabled As Boolean = True, Optional ShowUpBeforeEvent As Boolean = False)
    Dim btn As New Button
    With btn
        .Key = Key
        .Left = 14 + ButtonCount * 23 + SplitCount * 8
        .CheckStyle = CheckStyle
        .ToolTipText = ToolTipText
        .Enabled = ButtonEnabled
        .ShowUpBeforeEvent = ShowUpBeforeEvent
    End With
    ButtonCount = ButtonCount + 1
    Buttons.Add btn, Key
    #If IDEMODE = 1 Then
        Set btn.Icon = LoadResPicture(Key, 1)
        UserControl.PaintPicture btn.Icon, btn.Left, 6, 16, 16
    #Else
        btn.Icon = LoadImage(App.hInstance, Key, 1&, 16&, 16&, 0&)
        If ButtonEnabled Then
            DrawIconEx UserControl.hDC, btn.Left, 6, btn.Icon, 16, 16, 0, 0, 3
        Else
            DrawState UserControl.hDC, 0, 0, btn.Icon, 0, btn.Left, 6, 16, 16, &H3 Or DSS_DISABLED
        End If
    #End If
    btn.Left = btn.Left - 4
End Sub

Public Sub AddSplit()
Dim r As RECT
With r
    .Left = Buttons(ButtonCount).Left + 27
    .Top = 3
    .Right = .Left + 2
    .Bottom = 26
End With
DrawEdge UserControl.hDC, r, CLng(BDR_SUNKENOUTER Or BF_SOFT), BF_RECT
SplitCount = SplitCount + 1
End Sub

Private Sub UserControl_DblClick()
UserControl_MouseDown 0, 0, 0, 0
End Sub

Private Sub UserControl_Initialize()
Set Buttons = New Collection
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'ReleaseCapture
'UserControl_MouseMove 1, 1, -1, -1
SetCapture UserControl.hWnd
If CurButton Then
    ShowDown CurButton
    DownedButton = CurButton
    ButtonDowned = True
End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim t As Long
If ButtonDowned Then
    ButtonDowned = False
    t = GetCurButton(X, Y, 1, ButtonCount)
    With Buttons(DownedButton)
        If .Enabled = False Then Exit Sub
        If t = DownedButton And .ShowUpBeforeEvent Then RaiseEvent Click(Buttons(DownedButton), .Left, Y)
        If .CheckStyle Then
            If DownedButton = t Then
                If .Checked Then
                    .Checked = False
                    ShowUpWithRedraw DownedButton
                    ShowNull DownedButton
                Else
                    .Checked = True
                End If
            Else
                ShowUpWithRedraw DownedButton
                ShowNull DownedButton
            End If
        Else
            ShowUpWithRedraw DownedButton
            ShowNull DownedButton
        End If
        If t = DownedButton And Not .ShowUpBeforeEvent Then RaiseEvent Click(Buttons(DownedButton), .Left, Y)
    End With
    CurButton = 0
    DownedButton = 0
End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim t As Long
t = GetCurButton(X, Y, 1, ButtonCount)
If ButtonDowned Then
    If DownedButton <> t Then ShowNull DownedButton Else ShowDown DownedButton
Else
    If t Then
        SetCapture UserControl.hWnd
        If t <> CurButton Then
            ShowNull CurButton
            CurButton = t
            ShowUp CurButton
        End If
    Else
        ShowNull CurButton
        RaiseEvent ButtonHover(True, Nothing)
        ReleaseCapture
        CurButton = 0
    End If
End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim r As RECT
With r
    .Left = 4
    .Top = 1
    .Right = .Left + 3
    .Bottom = 28
End With
DrawEdge UserControl.hDC, r, CLng(BDR_RAISEDINNER Or BF_SOFT), BF_RECT
With r
    .Left = .Left + 4
    .Right = .Left + 3
End With
DrawEdge UserControl.hDC, r, CLng(BDR_RAISEDINNER Or BF_SOFT), BF_RECT
UserControl.ForeColor = UserControl.BackColor
bgBrush = CreateSolidBrush(UserControl.Point(1, 1))
Set CheckBack = LoadResPicture("checkback", 1)
End Sub

Private Sub UserControl_Resize()
UserControl.Height = 29 * Screen.TwipsPerPixelX
End Sub

Private Sub UserControl_Terminate()
DeleteObject bgBrush
Set CheckBack = Nothing
Set Buttons = Nothing
End Sub

Private Function GetCurButton(X As Single, Y As Single, ByVal StartIndex As Long, ByVal EndIndex As Long) As Long
On Error Resume Next
Dim t As Long, Index As Long
If Y < 3 Or Y > 26 Then
    Exit Function
End If
If Buttons(StartIndex).Left > X Then Exit Function
t = EndIndex
If Buttons(t).Left < X Then Index = t: GoTo kkk
Do
    If Buttons(t).Left >= X Then
        EndIndex = t
    Else
        StartIndex = t
    End If
    t = Round((EndIndex + StartIndex) / 2 + 0.1)
    If StartIndex = EndIndex - 1 Then
        Index = t - 1
        Exit Do
    End If
Loop
kkk:
If X - Buttons(Index).Left < 24 Then GetCurButton = Index
End Function

Private Sub ShowUp(btn As Long)
On Error GoTo kkk
With Buttons(btn)
    If .CheckStyle Then
        If .Checked Then
            RaiseEvent ButtonHover(False, Buttons(btn))
            Exit Sub
        End If
    End If
    Dim r As RECT
    r.Left = .Left + 1
    r.Top = 3
    r.Right = r.Left + 23
    r.Bottom = 26
    If .Enabled Then
        DrawEdge UserControl.hDC, r, CLng(BDR_RAISEDINNER Or BF_SOFT), BF_RECT
        UserControl.Refresh
    End If
    RaiseEvent ButtonHover(False, Buttons(btn))
End With
kkk:
End Sub

Private Sub ShowUpWithRedraw(btn As Long)
On Error GoTo kkk
Dim r As RECT
With r
    .Left = Buttons(btn).Left + 1
    .Top = 3
    .Right = .Left + 23
    .Bottom = 26
End With
FillRect UserControl.hDC, r, bgBrush
With Buttons(DownedButton)
    #If IDEMODE = 1 Then
        UserControl.PaintPicture .Icon, .Left + 4, 6, 16, 16
    #Else
        DrawIconEx UserControl.hDC, .Left + 4, 6, .Icon, 16, 16, 0, 0, 3
    #End If
End With
DrawEdge UserControl.hDC, r, CLng(BDR_RAISEDINNER Or BF_SOFT), BF_RECT
UserControl.Refresh
kkk:
End Sub

Private Sub ShowNull(btn As Long)
On Error GoTo kkk
If btn = 0 Then Exit Sub
Dim r As RECT
With r
    .Left = Buttons(btn).Left + 1
    .Top = 3
    .Right = .Left + 23
    .Bottom = 26
End With
With Buttons(btn)
    If .Enabled = False Then Exit Sub
    If .CheckStyle And .Checked Then Exit Sub
    If ButtonDowned Then
        FillRect UserControl.hDC, r, bgBrush
        #If IDEMODE = 1 Then
            UserControl.PaintPicture .Icon, .Left + 4, 6, 16, 16
        #Else
            DrawIconEx UserControl.hDC, .Left + 4, 6, .Icon, 16, 16, 0, 0, 3
        #End If
    End If
End With
Rectangle UserControl.hDC, r.Left, r.Top, r.Right, r.Bottom
UserControl.Refresh
kkk:
End Sub

Private Sub ShowDown(btn As Long)
On Error GoTo kkk
With Buttons(btn)
    If .Enabled = False Then Exit Sub
    If .CheckStyle Then
        If .Checked Then Exit Sub
    End If
    Dim r As RECT
    With r
        .Left = Buttons(btn).Left + 1
        .Top = 3
        .Right = .Left + 23
        .Bottom = 26
    End With
    FillRect UserControl.hDC, r, bgBrush
    If .CheckStyle Then
        UserControl.PaintPicture CheckBack, .Left + 3, 5, , , , , 19, 19
    End If
    #If IDEMODE = 1 Then
        UserControl.PaintPicture .Icon, .Left + 5, 7, 16, 16
    #Else
        DrawIconEx UserControl.hDC, .Left + 5, 7, .Icon, 16, 16, 0, 0, 3
    #End If
End With
DrawEdge UserControl.hDC, r, CLng(BDR_SUNKENOUTER Or BF_SOFT), BF_RECT
UserControl.Refresh
kkk:
End Sub

Public Sub UnFocusMe()
UserControl_MouseMove 1, 1, -1, -1
End Sub

Public Property Let Enabled(NewEnabled As Boolean)
mEnabled = NewEnabled
UserControl.Enabled = mEnabled
End Property

Public Property Get Enabled() As Boolean
Enabled = mEnabled
End Property

Public Property Get hWnd() As Long
hWnd = UserControl.hWnd
End Property

Public Sub SetButtonEnabled(Key As String, NewEnabled As Boolean)
With Buttons(Key)
    #If IDEMODE <> 1 Then
        Dim r As RECT
        r.Left = .Left
        r.Top = 3
        r.Right = .Left + 25
        r.Bottom = 26
        FillRect UserControl.hDC, r, bgBrush
        If NewEnabled Then
            DrawIconEx UserControl.hDC, .Left + 4, 6, .Icon, 16, 16, 0, 0, 3
        Else
            DrawState UserControl.hDC, 0, 0, .Icon, 0, .Left + 4, 6, 16, 16, &H3 Or DSS_DISABLED
        End If
        UserControl.Refresh
    #End If
    .Enabled = NewEnabled
End With
End Sub

Public Function GetButtonChecked(Key As String) As Boolean
GetButtonChecked = Buttons(Key).Checked
End Function

Public Sub SetButtonChecked(Key As String, NewChecked As Boolean)
If NewChecked = Buttons(Key).Checked Then Exit Sub
Dim r As RECT
With r
    .Left = Buttons(Key).Left + 1
    .Top = 3
    .Right = .Left + 23
    .Bottom = 26
End With
FillRect UserControl.hDC, r, bgBrush
With Buttons(Key)
    If NewChecked Then
        If .CheckStyle Then
            UserControl.PaintPicture CheckBack, .Left + 3, 5, , , , , 19, 19
        End If
        #If IDEMODE = 1 Then
            UserControl.PaintPicture .Icon, .Left + 5, 7, 16, 16
        #Else
            DrawIconEx UserControl.hDC, .Left + 5, 7, .Icon, 16, 16, 0, 0, 3
        #End If
        DrawEdge UserControl.hDC, r, CLng(BDR_SUNKENOUTER Or BF_SOFT), BF_RECT
    Else
        With Buttons(Key)
            #If IDEMODE = 1 Then
                UserControl.PaintPicture .Icon, .Left + 4, 6, 16, 16
            #Else
                DrawIconEx UserControl.hDC, .Left + 4, 6, .Icon, 16, 16, 0, 0, 3
            #End If
        End With
        Rectangle UserControl.hDC, r.Left, r.Top, r.Right, r.Bottom
    End If
End With
UserControl.Refresh
Buttons(Key).Checked = NewChecked
End Sub

Public Function GetButtonEnabled(Key As String) As Boolean
GetButtonEnabled = Buttons(Key).Enabled
End Function
