VERSION 5.00
Begin VB.UserControl flatCheckButton 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
End
Attribute VB_Name = "flatCheckButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Event Click()

Private mCaption As String
Private mCaptionLen As Long
Private mRect As RECT
Private mShowUpBeforeEvent As Boolean
Private Downed As Boolean
Private Enum ButtonStat
    Shown_Down
    Shown_Null
    Shown_Up
End Enum
Dim bs As ButtonStat
Public AlwaysShowUp As Boolean

Public Property Get Font() As Font
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
End Property

Public Property Let Caption(ByVal NewCaption As String)
mCaption = NewCaption
mCaptionLen = LenB(StrConv(mCaption, vbFromUnicode))
ShowNull
End Property

Public Property Get Caption() As String
Caption = mCaption
End Property

Public Property Let ShowUpBeforeEvent(ByVal newShowUpBeforeEvent As Boolean)
mShowUpBeforeEvent = newShowUpBeforeEvent
End Property

Public Property Get ShowUpBeforeEvent() As Boolean
ShowUpBeforeEvent = mShowUpBeforeEvent
End Property

'-----------
Private Sub UserControl_Resize()
With mRect
    .Right = ScaleWidth
    .Bottom = ScaleHeight
End With
End Sub

Private Sub UserControl_Paint()
ShowNull
End Sub

Private Sub UserControl_InitProperties()
Set UserControl.Font = Ambient.Font
Caption = Extender.Name
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
Caption = PropBag.ReadProperty("Caption", Extender.Name)
mShowUpBeforeEvent = PropBag.ReadProperty("ShowUpBeforeEvent", False)
AlwaysShowUp = PropBag.ReadProperty("AlwaysShowUp", False)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
PropBag.WriteProperty "Font", UserControl.Font, Ambient.Font
PropBag.WriteProperty "Caption", mCaption, Extender.Name
PropBag.WriteProperty "ShowUpBeforeEvent", mShowUpBeforeEvent, False
PropBag.WriteProperty "AlwaysShowUp", AlwaysShowUp, False
End Sub

Private Sub ShowUp()
If bs = Shown_Up Then Exit Sub
ShowNull
bs = Shown_Up
DrawEdge UserControl.hDC, mRect, CLng(BDR_RAISEDINNER Or BF_SOFT), BF_RECT
End Sub

Private Sub ShowDown()
If bs = Shown_Down Then Exit Sub
bs = Shown_Down
Dim r As RECT
With r
    .Right = ScaleWidth + 2
    .Bottom = ScaleHeight + 2
End With
UserControl.Cls
DrawText UserControl.hDC, mCaption, mCaptionLen, r, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
DrawEdge UserControl.hDC, mRect, CLng(BDR_SUNKENOUTER Or BF_SOFT), BF_RECT
End Sub

Private Sub ShowNull()
'If bs = Shown_Null Then Exit Sub
bs = Shown_Null
Dim r As RECT
With r
    .Right = ScaleWidth
    .Bottom = ScaleHeight
End With
UserControl.Cls
If AlwaysShowUp Then
    DrawEdge UserControl.hDC, mRect, CLng(BDR_RAISEDINNER Or BF_SOFT), BF_RECT
End If
DrawText UserControl.hDC, mCaption, mCaptionLen, r, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
'TextOut UserControl.hDC, d
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Downed = True
ShowDown
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
If x < 0 Or y < 0 Or x > ScaleWidth Or y > ScaleHeight Then
    If Downed Then

    Else
        ReleaseCapture
    End If
    ShowNull
Else
    If Downed Then
        ShowDown
    Else
        SetCapture UserControl.hWnd
        ShowUp
    End If
End If
End Sub

Private Sub UserControl_DblClick()
ShowDown
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'
ReleaseCapture
'If mShowUpBeforeEvent Then ShowNull
If x >= 0 And y >= 0 And x <= ScaleWidth And y <= ScaleHeight Then
    RaiseEvent Click
Else
    ShowNull
    Downed = False
End If
End Sub

Private Sub UserControl_Click()
'
End Sub

